print('Hello, World!\n');
print('This is an example script, showing the basics of how to use the scripted field processor.\n');
print('The print method used here results in output when the script is evaluated during processing.');
print('This can be useful for debugging.\n');

print('For example, the context variable "message" is an object of ' + message.getClass());
print('The email subject is a String, which for the selected test case email is:\n' + subject);

print('\nfromAddress is ' + fromAddress.getAddress());
for (i = 0; i < allAddresses.length; i++) {
    print('allAddresses #' + i + ' = ' + allAddresses[i].getAddress());
}

if (toAddresses) {
    for (i = 0; i < toAddresses.length; i++) {
        print('toAddresses #' + i + ' = ' + toAddresses[i].getAddress());
    }
}
if (ccAddresses) {
    for (i = 0; i < ccAddresses.length; i++) {
        print('ccAddresses #' + i + ' = ' + ccAddresses[i].getAddress());
    }
}
if (bccAddresses) {
    for (i = 0; i < bccAddresses.length; i++) {
        print('bccAddresses #' + i + ' = ' + bccAddresses[i].getAddress());
    }
}

//setting the below variable to true will instruct the field processor that a label for "hello-world" should be added
var isDemonstration = false;

if (isDemonstration) {
    print('\nSetting a label!');
    resultMap.put("labels", "hello-world");
    //see https://thepluginpeople.atlassian.net/wiki/spaces/JEMH/pages/2850827/Supported+Fields+for+use+with+Directives for the KEYS against which you can set values

    print('Setting the summary!');
    resultMap.put("summary", "This will be the final summary");
    //uncomment the next line to force the field processor to always win over other field processors
    //resultMap.put("FORCE_JEMH_SCRIPTFP", true);

    //see https://thepluginpeople.atlassian.net/wiki/spaces/JEMH/pages/387219457/Defining+message+outcomes
    //jemhUtils.filterMessage(String reason) -- filtered, JEMH should not process the message, and should leave it in the mailbox
    //jemhUtils.forwardMessage(String reason) -- JEMH should not process the message, send to the 'forward' address, and delete the message from the mailbox
    //jemhUtils.rejectMessage(String reason) -- JEMH should not process the message, send a reject hintOgram to the sender and delete the message from the mailbox
    //jemhUtils.dropMessage(String reason) -- JEMH should not process the message, the message should be deleted silently from the mailbox
}
